#ifndef defs_h
#define defs_h

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <math.h>
#include <tk.h>
#include <tkPhoto.h>

/* structure representing one pixel's worth of RGB values in 24-bit */
/* color */
struct Pixel
{
  unsigned char red;
  unsigned char green;
  unsigned char blue;
};

typedef struct Pixel pixel;

extern pixel **colors;

/* functions in double.c */
extern void process(char *filename, int *height, int *width, int *maxval,
		    pixel ***colors);
extern void cleanup(pixel **what, int height);
extern void magnify(int height, int width);
extern void shrink(int *height, int *width);
extern void dump(char *filename, int height, int width, int maxval,
		 pixel **grid);

/*functions in block.c */
extern int roundup(float num);
extern int rounddown(float num);
extern void dump_block(char *filename, int height, int width, int
		       StartVert, int StartHoriz, int maxval);
extern void dump_into_blocks(char *filebase, int height, int width,
			     int maxval, int start);
extern void process_in_blocks(char *filename, int *height, int *width, 
			      int *maxval, pixel ***grid, int power);

/* functions in concat.c */
extern void dump_to_photo(PhotoHandle pp, unsigned char *RGB, 
			  int height, int width);
extern void concat_files(PhotoHandle pp, char *filenames[4]);

#endif
